const rule = require('./index');
describe('test rule', () => {
  const subjectJira = rule.rules["subject-jira"];
  test('如果subject是undefined', () => {
    expect(subjectJira({}).length).toBe(1);
  });
  test('如果subject是空', () => {
    expect(subjectJira({
      subject: null
    }).length).toBe(1);
  });
  test('never情况下,subject为1', () => {
    expect(subjectJira({
      subject: '1',
    },'never')).toContain('subject is perfect');
  });
  var notMatchText = 'subject is not match,should like <ISSUE_KEY1> <ISSUE_KEY2> <ISSUE_KEY3> #comment content #time 5h 5m '
  let testArr =  [
    {
      text:'asd-123 #cc',
      expect: notMatchText
    },
    {
      text: 'asd-123 #cc',
      expect: notMatchText
    },
    {
      text: 'JIRA-123 #comment ',
      expect: notMatchText
    },
    {
      text: 'JIRA-123 #comment',
      expect: notMatchText
    },
    {
      text: 'JIRA-123 #comment 你 #time 5h zsdlsjd asdasdasdas10',
      expect: notMatchText
    },
    {
      text: 'JIRA-123 #comment asd #time 5h 3m',
      expect: true
    },
    {
      text: 'JIRA-123 #comment asd #time 5h',
      expect: true
    },
    {
      text: 'JIRA-123 #comment asd #time 5.1h',
      expect: true
    },
    {
      text: 'JIRA-123 #comment asd #time 5.3h 3.1m',
      expect: notMatchText
    },
    {
      text: 'JIRA-123 #comment as d #time 5.3h 3.1m',
      expect: notMatchText
    },
    {
      text: 'JIRA-123 #comment asd  #time 5h 31m',
      expect: notMatchText
    },
    {
      text: 'JIRA-123 #comment a sd  #time 5h 31m',
      expect: notMatchText
    },
    {
      text: 'JIRA-123 #comment a sd  #time 5h 31m',
      expect: notMatchText
    },
    {
      text: 'JIRA-333 #close #time 12323',
      expect: notMatchText
    },
    {
      text: 'JIRA-333 #close #time 5h cjkask',
      expect: true
    },
    {
      text: 'JIRA-333 #close #time 5h cjka sk',
      expect: notMatchText
    },
    {
      text: 'JIRA-333 #closasdasd #time 5h cjka sk',
      expect: notMatchText
    },
    {
      text: 'JIRA-333 #comment ',
      expect: notMatchText
    },
    {
      text: 'JIRA-333 #close #time 5h 5m 测试包',
      expect: true
    },
    {
      text: 'JIRA-333 #time 5h 5m 测试包',
      expect: true
    },
    {
      text: 'JIRA-333 JIRA-333 #time 5h 5m 测试包',
      expect: true
    },
    {
      text: 'JIRA-33 #close 123123123 #time 5h 10m 按实际很看好的',
      expect: notMatchText
    }

    // 'JIRA-123 #comment asd #time 5h 3m',
    // 'JIRA-123 #comment asd #time 5d',
    // 'JIRA-123 #comment 安生 #time 5h 啊实打实大',
    // 'JIRA-123 #comment 啊飒飒的是东航#time asdsad',
    // 'JIRA-333 #close #time  12323',
    // 'JIRA-333 #close #time  3masdasd',
    // 'JIRA-333 #close #time  5h 3m 12323',
    // 'JIRA-333 #close #comment 12323',
    // 'JIRA-33 #close 123123123 #time 5h 10m 按实际很看    好的',
    // 'JIRA-33 #close #comment 123123 #time 5h 10m 按实际很看好的'
  ]
  for (let item of testArr) {
    test(`always情况下,subject为${item.text}`, () => {
      expect(subjectJira({
        subject: item.text,
      }, 'always')).toContain(item.expect);
    });
  }
  
  // test('always情况下,subject为asd-123', () => {
  //   expect(subjectJira({
  //     subject: 'asd-123',
  //   }, 'always')).toContain('subject is not match');
  // });
  // test('always情况下,subject为JIRA-123', () => {
  //   expect(subjectJira({
  //     subject: 'JIRA-123',
  //   }, 'always')).toContain('subject is not match');
  // });
  // test('always情况下,subject为JIRA-123 #time', () => {
  //   expect(subjectJira({
  //     subject: 'JIRA-123 #time',
  //   }, 'always')).toContain('subject is not match');
  // });
  // test('always情况下,subject为JIRA-123 #time', () => {
  //   expect(subjectJira({
  //     subject: 'JIRA-123 #comment ',
  //   }, 'always')).toContain('subject is not match');
  // });
})

// 'asd-123 #cc',
// 'asd-123 #comment asd',
// 'JIRA-123 #comment ',
// 'JIRA-123 #comment 你 #time 5h zsdlsjd asdasdasdas10m',
// 'JIRA-123 #comment asd #time 5h 3m',
// 'JIRA-123 #comment asd #time 5d',
// 'JIRA-123 #comment 安生 #time 5h 啊实打实大',
// 'JIRA-123 #comment 啊飒飒的是东航#time asdsad',
// 'JIRA-333 #close #time  12323',
// 'JIRA-333 #close #time  3masdasd',
// 'JIRA-333 #close #time  5h 3m 12323',
// 'JIRA-333 #close #comment 12323',
// 'JIRA-33 #close 123123123 #time 5h 10m 按实际很看    好的',
// 'JIRA-33 #close #comment 123123 #time 5h 10m 按实际很看好的'